# mobioo v0.1 for s60, a ODT reader, (c) V.Ganesh, GPL
import appuifw,e32,sysinfo,string,zlib,zipfile,xml
import xml.parsers.expat
from sysinfo import *
from appuifw import *
from e32 import *
from key_codes import *
from os.path import *

OO_CONTENT = 'content.xml'

class filechooser:
     def __init__(self):
         self.current_path = "<root>"

     def show(self, filters=None):
         filelist = e32.drive_list()
         while (1):
            ll = []
            for file in filelist:
               if (filters != None):
                  if isfile(self.current_path + "\\" + file):
                     matched = 0; filext = splitext(file)[1]
                     for filter in filters:
                         if (filext == filter):
                            matched = 1; break
                     if (matched == 0): continue
               ll.append(unicode(file))
                 
            ind = selection_list(ll)
             
            if ind is not None:
              if (self.current_path == "<root>"):
                  self.current_path = ll[ind]
                  filelist = os.listdir(self.current_path)
                  continue
              if not isfile(self.current_path + "\\" + ll[ind]):
                  self.current_path = self.current_path + "\\" + ll[ind]
                  filelist = os.listdir(self.current_path)
                  continue
              return self.current_path + "\\" + ll[ind]
            else:
              self.current_path = "<root>"
              return None

class ootxtprp:
    def __init__(self):
        self.fwidth=""; self.fstyle=""; self.fcolor=""; self.fsize=""
        self.tunderln=""; self.tlinethr=""
        
class oostyl:
    def __init__(self, name="Standard"):
        self.name=name; self.family=""; self.parent=""
        self.txtPrp=ootxtprp()
        
class mobioo:
    def __init__(self):
        self.script_lock = e32.Ao_lock()

    def run(self):
        self.old_body = appuifw.app.body
        self.old_screen = appuifw.app.screen
        self.old_title = appuifw.app.title

        self.styList = {}
        self.styList["Standard"] = oostyl()
        self.curStyl = None
        
        self.initUi()
        self.script_lock.wait()
        appuifw.app.title = self.old_title

    def initUi(self):
        appuifw.app.title = u"mobioo v0.1, (c)V.Ganesh"
        appuifw.app.menu = [(u"Open", self.do_open),
                            (u"Screen mode",
                              ((u"Full screen", self.do_full_screen),
                               (u"Normal screen", self.do_normal_screen))),
                            (u"About", self.do_about)
                           ]
        appuifw.app.exit_key_handler = self.exit_key_handler
        self.odtArea = Text()
        appuifw.app.body = self.odtArea

    def do_about(self):
        note(appuifw.app.title, 'info')
        
    def do_open(self):
        self.filename = filechooser().show([".odt"])

        if (self.filename == None): return
        self.open()

    def start_element(self, name, attrs):
        if (name.find("style:style") >= 0):
             self.curStyl = oostyl()
             self.curStyl.name = attrs["style:name"]
             self.curStyl.family = attrs["style:family"]
             self.curStyl.parent = attrs["style:parent-style-name"]
             
        if (name.find("style:text-properties") >= 0):
             if (self.curStyl != None):
                 for attr in attrs:
                      if (attr.find("fo:font-weight") >= 0):
                           self.curStyl.txtPrp.fwidth = attrs[attr]
                      if (attr.find("fo:font-style") >= 0):
                           self.curStyl.txtPrp.fstyle = attrs[attr]
                      if (attr.find("fo:color") >= 0):
                           self.curStyl.txtPrp.fcolor = attrs[attr]
                      if (attr.find("fo:font-size") >= 0):
                           self.curStyl.txtPrp.fsize = attrs[attr]                           
                      if (attr.find("style:text-underline-style") >= 0):
                           self.curStyl.txtPrp.tunderln = attrs[attr]
                      if (attr.find("style:text-line-through-style") >= 0):
                           self.curStyl.txtPrp.tlinethr = attrs[attr]

        if (name.find("text:p") >= 0):
             self.setStyle(attrs["text:style-name"])

    def getColorTuple(self, col):
        r = string.atoi("0x" + col[1:3], 16)
        g = string.atoi("0x" + col[3:5], 16)
        b = string.atoi("0x" + col[5:7], 16)
        return (r, g, b)

    def getFontStr(self, sz):
        s = string.atoi(sz[0:2])
        if (s <= 12): return u'LatinPlain12'
        if ((s > 12) and (s < 16)): return u'LatinBold13'
        if ((s >= 16) and (s < 18)): return u'LatinBold17'
        if (s >= 18): return u'LatinBold19'
                
    def setStyle(self, style):
        try:
             styl = self.styList[style]
             self.odtArea.font = u'LatinPlain12'
             self.odtArea.style = 0
             self.odtArea.color = (0,0,0)
             
             if (styl.txtPrp.fwidth.find("bold") >= 0):
                  self.odtArea.style = self.odtArea.style | STYLE_BOLD
             if (styl.txtPrp.fstyle.find("italic") >= 0):
                  self.odtArea.style = self.odtArea.style | STYLE_ITALIC
             if (styl.txtPrp.tunderln.find("solid") >= 0):
                  self.odtArea.style = self.odtArea.style | STYLE_UNDERLINE
             if (styl.txtPrp.tlinethr.find("solid") >= 0):
                  self.odtArea.style = self.odtArea.style | STYLE_STRIKETHROUGH
             if (styl.txtPrp.fcolor != ""):
                  self.odtArea.color = self.getColorTuple(styl.txtPrp.fcolor)
             if (styl.txtPrp.fsize != ""):
                  self.odtArea.font = self.getFontStr(styl.txtPrp.fsize)
        except:
             self.odtArea.font = u'LatinPlain12'
             self.odtArea.style = 0
             self.odtArea.color = (0,0,0)
        
    def end_element(self, name):
        if (self.curStyl != None):
             self.styList[self.curStyl.name] = self.curStyl
         
    def char_data(self, data):
        self.odtArea.add(unicode(data) + u'\n')
         
    def open(self):
        self.odtArea.font = u'LatinPlain12'
        self.odtArea.color = (0,0,0)

        oofil = zipfile.ZipFile(self.filename)
        p = xml.parsers.expat.ParserCreate()
        p.StartElementHandler = self.start_element
        p.EndElementHandler = self.end_element
        p.CharacterDataHandler = self.char_data
        p.Parse(oofil.read(OO_CONTENT))
        oofil.close()
        oofil = None
        p = None
        self.curStyl = None
        self.styList = {}; self.styList["Standard"] = oostyl()
        self.odtArea.set_pos(0)
        
    def do_full_screen(self):
        appuifw.app.screen='full'

    def do_normal_screen(self):
        appuifw.app.screen='normal'
         
    def do_exit(self):
        self.exit_key_handler()

    def exit_key_handler(self):
        appuifw.app.exit_key_handler = None
        appuifw.app.body = self.old_body
        appuifw.app.screen = self.old_screen
        self.script_lock.signal()
        if appuifw.app.full_name()[-10:] != "Python.app":
            appuifw.app.set_exit()
            
if __name__=="__main__":
    mobioo().run()          
